import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

public class Checkbook {

    //blind us with your Java eloquence....
    Payee owner;
    double amount;

    List<Transaction> transactions = new ArrayList<>();

    public Checkbook(double cashAmount) {
        this.amount = cashAmount;
        new Checkbook(new Payee(), cashAmount);
    }

    public Checkbook(Payee owner, double cashAmount ) {
        this.owner = owner;
        this.amount = cashAmount;
    }

    public int size(){
        return transactions.size();
    }

    public boolean isEmpty(){
        return transactions.isEmpty();
    }

    public boolean contains(Transaction element){
        return transactions.contains(element);
    }

    public boolean add(Transaction element){
        return transactions.add(element);
    }

    public boolean remove(Transaction element){
        return transactions.remove(element);
    }

    public Iterator iterator(){
        return transactions.iterator();
    }

    public Transaction[] toArray(){
        return transactions.toArray(new Transaction[transactions.size()]);
    }

    public Transaction[] toArray(Transaction[] a){
        transactions.addAll(Arrays.asList(a));
        return transactions.toArray(new Transaction[transactions.size()]);
    }

    public double checkbookValue(){
        double sum = 0;
        for(Transaction transaction : transactions){
            sum += transaction.getAmount();
        }
        return sum;
    }

    public Transaction[] getTransactionsForDate(LocalDate aDate){
        List<Transaction> list = new ArrayList<>();
        for(Transaction transaction : transactions){
            if(aDate.equals(transaction.getDate()))
                list.add(transaction);
        }

        /*list = transactions.stream().collect(Collectors.groupingBy(Transaction::getDate))
                .*/

        return list.toArray(new Transaction[0]);
    }


    public Transaction[] getAllTransactionsForPayee(String name) {
        List<Transaction> list = new ArrayList<>();
        for(Transaction transaction : transactions){
            if(transaction.getPayee().getGivenName().equals(name)){
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[list.size()]);
    }

    public Transaction[] getAllDebitTransactions() {
        List<Transaction> list = new ArrayList<>();
        for(Transaction transaction : transactions){
            if(transaction.getType().equals(TransactionType.DEBIT)){
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[list.size()]);
    }

    public Transaction[] getAllCreditTransactions() {
        List<Transaction> creditTransactions = new ArrayList<>();
        for(Transaction transaction : transactions){
            if(transaction.getType().equals(TransactionType.CREDIT))
                 creditTransactions.add(transaction);
        }
        return creditTransactions.toArray(new Transaction[creditTransactions.size()]);
    }

    public boolean containsAll(List<Transaction> transactions2) {
        return transactions.containsAll(transactions2);
    }


    public boolean addAll(List<Transaction> transactions2) {
        return transactions.addAll(transactions2);
    }

    public boolean removeAll(List<Transaction> transactions2) {
        return transactions.removeAll(transactions2);
    }

    public void clear() {
        transactions.clear();
    }
}
