import junit.framework.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

public class GenericAccountTest {
    Payee payee;
    Checkbook checkbook;
    GenericAccount genericAccount;

    @Before
    public void setup(){
        payee = new Payee();
        payee.setGivenName("thulasi");
        payee.setFamilyName("puppala");
        payee.setEmailAddress("thulasi@gmail.com");
        checkbook = new Checkbook(payee, 20000);
        genericAccount = new GenericAccount(payee, checkbook);
    }

    @Test
    public void TestGetPayee(){
        Payee expected = payee;
        Payee actualPayee = genericAccount.getPayee();
        Assert.assertEquals(expected, actualPayee);
    }

    @Test
    public void TestGetCheckbook(){
        Checkbook expected = checkbook;
        Checkbook actual = genericAccount.getCheckbook();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void TestSetGetTransaction(){
        List<Transaction> expected = new ArrayList<>();
        expected.add(new Transaction("one", payee, TransactionType.DEBIT, 200.0));
        genericAccount.setTransaction(expected);
        List<Transaction> actual = genericAccount.getTransaction();
        Assert.assertEquals(expected, actual);
    }
}
